import { TwingNode, TwingNodeComment, TwingNodeExpressionArray, TwingNodeExpressionAssignName, TwingNodeExpressionBinary, TwingNodeExpressionConstant, TwingNodeExpressionFunction, TwingNodeExpressionGetAttr, TwingNodeExpressionName, TwingNodeFor, TwingNodeIf, TwingNodePrint, TwingNodeText } from 'twing';
export declare class Transpiler {
    private readonly _functions;
    constructor();
    protected transpileCommentNode(node: TwingNodeComment): string;
    protected transpileExpressionBinaryNode(node: TwingNodeExpressionBinary): string;
    protected transpileExpressionNameNode(node: TwingNodeExpressionName): string;
    protected transpileExpressionAssignNameNode(node: TwingNodeExpressionAssignName): string;
    protected transpileExpressionConstantNode(node: TwingNodeExpressionConstant, raw: boolean): string;
    protected transpileExpressionGetAttrNode(node: TwingNodeExpressionGetAttr): string;
    protected transpileExpressionArrayNode(node: TwingNodeExpressionArray): string;
    protected transpileForNode(node: TwingNodeFor): string;
    protected transpileIfNode(node: TwingNodeIf): string;
    protected transpilePrintNode(node: TwingNodePrint): string;
    protected transpileTextNode(node: TwingNodeText): string;
    protected transpileExpressionFunctionNode(node: TwingNodeExpressionFunction): string;
    transpileNode(node: TwingNode, raw?: boolean): string;
    transpile(code: string): string;
    /**
     * Register a function to the transpiler.
     *
     * @param name
     */
    registerFunction(name: string): void;
}
